/* 
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY

#include "particle_system.h"

#include "particle_emitter.h"
#include "particle_engine.h"
#include "compiler.h"

using namespace std;


/**
   \brief standard constructor
   \param count the Count of particles in the System
   \param type The Type of the ParticleSystem

   \todo this constructor is not jet implemented - do it
*/
ParticleSystem::ParticleSystem (unsigned int count, PARTICLE_TYPE type) 
{
   this->setClassName ("ParticleSystem");

   this->particleType = type;
   this->particles = NULL;
   this->conserve = 1.0;
   this->setLifeSpan(5.0);

   ParticleEngine::getInstance()->addSystem(this);
}


/**
   \brief standard deconstructor

*/
ParticleSystem::~ParticleSystem() 
{
  // delete what has to be deleted here
}

// setting properties
void ParticleSystem::setMaterial(Material* material)
{
  
}

void ParticleSystem::setLifeSpan(float lifeSpan, float randomLifeSpan)
{

}

void ParticleSystem::setRadius(float startRadius, float endRadius, float randomRadius)
{

}

void ParticleSystem::setConserve(float conserve)
{
  this->conserve = conserve;
}



void ParticleSystem::tick(float dt)
{
  Particle* tmpPart = particles;
  while (likely(tmpPart != NULL))
    {
      tmpPart->position = tmpPart->position + tmpPart->velocity;

      // many more to come

      tmpPart = tmpPart->next;
    }
}

void ParticleSystem::draw(void)
{
  Particle* tmpPart = particles;
  if (likely(tmpPart != NULL))
    {
      glBegin(GL_POINTS);
      while (likely(tmpPart != NULL))
	{
	  // draw in DOT mode
	  glVertex3f(tmpPart->position.x, tmpPart->position.y, tmpPart->position.z);
	  
	  
	  tmpPart = tmpPart->next;
	}
      glEnd();
    }
}


void ParticleSystem::addParticle(Vector position, Vector velocity, unsigned int data)
{
  // if it is the first Particle
  if (unlikely(particles == NULL))
    {
      this->particles = new Particle;
      this->particles->next = NULL;
    }
  // filling the List from the beginning
  else
    {
      Particle* tmpPart = new Particle;
      tmpPart->next = this->particles;
      this->particles = tmpPart;
    }
  
  particles->timeToLive = this->lifeSpan + (float)(random()/RAND_MAX)* this->randomLifeSpan;
  particles->position = position;
  particles->velocity = velocity;
  //  particle->rotation = ; //! \todo rotation is once again something to be done.
  particles->mass = this->initialMass + (random()/RAND_MAX)* this->randomInitialMass;
  particles->radius = this->startRadius + (random()/RAND_MAX)*this->randomRadius;
}

